package com.logicbig.example;

import com.logicbig.example.app1.MyWebConfig;
import com.logicbig.example.app2.MyWebConfig2;
import org.springframework.web.WebApplicationInitializer;
import org.springframework.web.context.support.AnnotationConfigWebApplicationContext;
import org.springframework.web.servlet.DispatcherServlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRegistration;

public class MyWebInitializer implements WebApplicationInitializer {

    @Override
    public void onStartup(ServletContext servletContext) throws ServletException {
        registerSpringContext(servletContext, MyWebConfig.class, "dispatcher1", "/app1/*");
        registerSpringContext(servletContext, MyWebConfig2.class, "dispatcher2", "/app2/*");
    }

    private void registerSpringContext(ServletContext servletContext, Class<?> configClass,
                                       String servletName, String mapping) {
        AnnotationConfigWebApplicationContext ctx =
                new AnnotationConfigWebApplicationContext();
        ctx.register(configClass);
        ctx.setServletContext(servletContext);

        ServletRegistration.Dynamic servlet =
                servletContext.addServlet(servletName, new DispatcherServlet(ctx));
        servlet.setLoadOnStartup(1);
        servlet.addMapping(mapping);
    }
}